﻿//FUNCION PARA CREAR LAS DIMENSIONES
function Crear_Dimensiones(DataArray) {
//console.log("Creando dimensiones")
    CrearGrupos(DataArray);
    agruparCombinaciones(GrupoActivas, GrupoCos, DataArray);

    arrayDatos = crossfilter(DataArray);
    all = arrayDatos.groupAll();
    activa = arrayDatos.dimension(function (d) { return d.Active });
    activas = activa.group(function (d) { return Math.floor(d / 5) * 5 }).reduce(reduceAdd, reduceRemove, reduceInit);
    powerFactor = arrayDatos.dimension(function (d) { return d.cosPhi });
    powerFactors = powerFactor.group(function (d) { return Math.floor(d * 100) / 100 }).reduce(reduceAdd, reduceRemove, reduceInit);
    hour = arrayDatos.dimension(function (d) { return d.Hour; });
    hours = hour.group().reduce(reduceAdd, reduceRemove, reduceInit);
    weekDay = arrayDatos.dimension(function (d) { return d.W_n; });
    weekDays = weekDay.group().reduce(reduceAdd, reduceRemove, reduceInit);
    month = arrayDatos.dimension(function (d) { return d.M_n; });
    months = month.group().reduce(reduceAdd, reduceRemove, reduceInit);
    building = arrayDatos.dimension(function (d) { return d.Building });
    buildings = building.group().reduce(reduceAdd, reduceRemove, reduceInit);
    holiday = arrayDatos.dimension(function (d) { return d.Holiday });
    holidays = holiday.group().reduce(reduceAdd, reduceRemove, reduceInit);
    //cost = arrayDatos.dimension(function (d) { return d.Price });
   // costs = cost.group();
    bidi = arrayDatos.dimension(function (d) { return d.Group });
    bidi_grupo = bidi.group();

    dimensionGroups = [activas.all(), powerFactors.all(), hours.all(), weekDays.all(), months.all(), holidays.all(), buildings.all()];
}

//FUNCION PARA CREAR TODOS LOS HISTOGRAMAS
function Crear_Histogramas() {
    Crear_Histo(activa, activas, '#svg_Activa', 0, 0, reduceOK);
    Crear_Histo(powerFactor, powerFactors, '#svg_cosPhi', 0, 0, reduceOK);
    Crear_Histo(hour, hours, '#svg_Hora', 0, 1, reduceOK);
    Crear_Histo(weekDay, weekDays, '#svg_Dia', 0, 1, reduceOK);
    Crear_Histo(month, months, '#svg_Mes', 0, 1, reduceOK);
    Crear_Histo(holiday, holidays, '#svg_Holiday', 1, 1, reduceOK);
    Crear_Histo(building, buildings, '#svg_Edificio', 1, 1, reduceOK);
}

//FUNCION PARA ELIMINAR TODOS LOS HISTOGRAMAS
function EliminarHistos() {
    $('#svg_Activa').empty();
    $('#svg_cosPhi').empty();
    $('#svg_Hora').empty();
    $('#svg_Dia').empty();
    $('#svg_Mes').empty();
    $('#svg_Holiday').empty();
    $('#svg_Edificio').empty();
}

// FUNCION PARA CREAR UN HISTOGRAMA CON COMBINACIONES DE 2 DIMENSIONES DE CROSSFILTER
function Crear_Histo2D(dimension, grupo, targetDiv) {

    var sizeScatter = canvasSize(targetDiv);
    margenH_2D = sizeScatter[1] / 4;
    margenV_2D = sizeScatter[1] / 12;  
 
    var datos = dimension.top(Infinity);
    var datos_grupo = grupo.all();
    
    var Xmin_max = d3.extent(datos, function (d) { return d.Active });
    var Xescala = d3.scale.linear().domain([0, 450]).range([margenH_2D, sizeScatter[0] - margenH_2D]);
    var Ymin_max = d3.extent(datos, function (d) { return d.cosPhi });
    var Yescala = d3.scale.linear().domain([0.44, 1]).range([margenV_2D, sizeScatter[1] - margenV_2D]);

    var Colormax = d3.max(datos_grupo, function (d) { return d.value; });
    var colorscale = d3.scale.quantize().domain([1, Colormax]).range(colorbrewer.Reds[7]);

    var Radiomax = d3.max(datos_grupo, function (d) { return d.value; });
    var Radioscale = d3.scale.linear().domain([0, Radiomax]).range([0, 15]);

    var Axis_Xescala = d3.scale.linear().domain([0, 450]).range([margenH_2D, sizeScatter[0] - margenH_2D, ]);
    var Axis_Yescala = d3.scale.linear().domain([0.44, 1]).range([sizeScatter[1] - margenV_2D, margenV_2D]);
    
    var Yaxis = d3.svg.axis().scale(Axis_Yescala).orient("left").ticks(8);
    var Xaxis = d3.svg.axis().scale(Xescala).orient("bottom").ticks(20);

    fore = d3.select(targetDiv).append("foreignObject")
        .attr("id", "foreing")
        .attr("x", sizeScatter[0]/2) 
        .attr("y", sizeScatter[1]/2)
        .attr("width", 90)
        .attr("height", 40)
        .append("xhtml:div")
        .attr("id", "Cuadro_Inform");

     coord2D = d3.select(targetDiv).selectAll("g")
        .data(datos_grupo)
        .enter()
        .append("g")
        .attr("transform", function (d) { return "translate(" + Xescala(pos[d.key][0]) + "," + (sizeScatter[1] - Yescala(pos[d.key][1]) - margenV_2D) + ")" });

    coord2D.append("circle")
    .attr("r", function (d) { return 5 })
    .style("fill", function (d) { if (d.value >= 1) return colorscale(d.value); if (d.value == 0) return "white" })
    .on("mouseover", hover)
    .on("mouseout",mouseOut);

    d3.select(targetDiv).append("g")
         .attr("class", "axis")
         .attr("transform", "translate(0," + (sizeScatter[1] - margenV_2D) + ")")
         .call(Xaxis);

    d3.select(targetDiv).append("g")
         .attr("class", "axis")
         .attr("transform", "translate(" + margenH_2D + ",0)")
         .call(Yaxis);
/*
    var brush2D = d3.svg.brush()
                    .x(Xescala)
                    .y(Axis_Yescala)
                    .on("brushend", Brushed);

    d3.select(targetDiv).append("g").attr("class", ".brush2D").call(brush2D);

   // .selectAll("rect").attr("transform","translate(0," + 0.5*margenVer + ")").attr("height", sizeChart[1] - (margenVer *1.5));
   // d3.selectAll("g.resize > rect").style("visibility", "visible");

    function Brushed() {
        var e = brush2D.extent(); console.log(e)
        
        activa.filter([e[0][0], e[1][0]]);
        powerFactor.filter([e[0][1], e[1][1]]);

        var grupo = d3.select(targetDiv).selectAll("circle")
        grupo.each(function (d) {
            if (d.key >= e[0][0] && d.key <= e[1][0]
                && d.key >= e[0][1] && d.key <= e[1][1])
            {
                d.selected=true;
            }
            else
            {
                d.selected=false;
            }
        });
        
        update();
    }
    
 */   
}

//FUNCION PARA CREAR UN HISTOGRAMA CON EJE CUANTIZADO U ORDINAL, INDICANDO SI VA ARRIBA O ABAJO EN LA PLANTILLA Y SI USA RECUCE O NO
function Crear_Histo(dimension, grupo, targetDiv, ordinal, abajo, gruposConReduce, usarReduce) {

    ordinal = ordinal || 0; abajo = abajo || 0; gruposConReduce = gruposConReduce || 0; usarReduce = usarReduce || 0; var aux = 0;

    var sizeChart = canvasSize(targetDiv);
    var x = grupo.all()

    margenHor = sizeChart[1] / 5;         //Dejo margen suficiente margen a izquierda para colocar el eje Y con sus respectivos valores
    margenHorDerecho = sizeChart[1] / 5; //Dejo un margen diferente , y muy pequeño, a la derecha ya que a ese lado no va nada
    margenVer = sizeChart[1] / 8;
    ancho_bar = (sizeChart[0] - margenHor - margenHorDerecho) / x.length;

    // creo 2 margenes diferentes para la funcion update() que se hara a posteriori, en funcion de si los histogramas son los de arriba o los de abajo
    if (abajo == 0) {
        size = sizeChart;
        margenVer1 = sizeChart[1] / 8;
    }
    else {
        size2 = sizeChart;
        margenVer2 = sizeChart[1] / 8;
        margenHor = sizeChart[1] / 2.5; // Doy un margen horizontal menor en los histos de abajo
        margenHorDerecho = sizeChart[1] / 18;
        ancho_bar = (sizeChart[0] - margenHor - margenHorDerecho) / x.length;

        if (ordinal == 1) {
            margenHor = sizeChart[1] / 2.5;  //Modifico el margen de los dos ultimos histogramas para ver correctamente el valor en euros con cifras altas
            
        }
    }

    var Xmin_max = d3.extent(x, function (d) { return d.key });
    var Xvalues = x.map(function (d) { return d.key }),
        Xescala = d3.scale.ordinal().domain(Xvalues).rangeBands([margenHor, sizeChart[0] - margenHorDerecho]);

    //Creo los ejes x de cada grafica en funcion de la dimension y el grosor de las barras                                            
    if (dimension == weekDay) {
        var DaysArray = ['Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat', 'Sun'];
        var Axis = d3.svg.axis().scale(Xescala).orient("bottom");

        if (ancho_bar < 20) {
            Axis.tickFormat(function (d, i) {
                if (i % 2 == 0) {
                    return DaysArray[i]
                };
            })
        }
        else Axis.tickFormat(function (d) {
            return DaysArray[d]
        });
    }
    else
        if (dimension == month) {
            var MonthsArray = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'];
            var Axis = d3.svg.axis().scale(Xescala).tickFormat(function (d) { return MonthsArray[d - 1]; }).orient("bottom");

            if (ancho_bar < 20) {
                Axis.tickFormat(function (d, i) {
                    if (i % 2 == 0) {
                        return MonthsArray[i]
                    };
                })
            }
            else Axis.tickFormat(function (d) {
                return MonthsArray[d - 1]
            });
        }
        else {
            if (ancho_bar > 18) {
                var Axis = d3.svg.axis().scale(Xescala).orient("bottom").ticks(x.length);
            }
            else if (ancho_bar >= 12 && ancho_bar <= 18) {
                var Axis = d3.svg.axis().scale(Xescala).orient("bottom").tickValues(Xvalues.filter(function (d, i) { if (i % 2 == 0) return d }));
            }
            else if (ancho_bar >= 10 && ancho_bar < 12) {
                var Axis = d3.svg.axis().scale(Xescala).orient("bottom").tickValues(Xvalues.filter(function (d, i) { if (i % 4 == 0) return d }));
            }
            else if (ancho_bar < 10) {
                var Axis = d3.svg.axis().scale(Xescala).orient("bottom").tickValues(Xvalues.filter(function (d, i) { if (i % 5 == 0) return d }));
            }
       }

    if (gruposConReduce == 0) {
       // console.log("Creacion histograma sin reduce")

        var Ymax = d3.max(grupo.all(), function (d) { return d.value }),
        Yescala = d3.scale.linear().domain([0, Ymax]).range([0, sizeChart[1] - 1.5 * margenVer]);

        var CardinalRect = d3.select(targetDiv).selectAll("rect.histobar")
         .data(grupo.all())
         .enter()
         .append("rect")
         .attr("class", "histobar")
         .attr("width", ancho_bar)
         .attr("height", function (d) { return Yescala(d.value); })
         .attr("x", function (d, i) { return (margenHor + i * ancho_bar) })
         .attr("y", function (d) { return (sizeChart[1] - Yescala(d.value) - margenVer) });
    }
    else {
        //console.log("Creacion correcta histogramas por camino reduceOK")                                                  

        var Ymax = d3.max(grupo.all(), function (d) { return d.value.count }),
        Yescala = d3.scale.linear().domain([0, Ymax]).range([0, sizeChart[1] - 1.5 * margenVer]);

        var CardinalRect = d3.select(targetDiv).selectAll("rect.histobar")
         .data(x)
         .enter()
         .append("rect")
         .attr("class", "histobar")
         .attr("width", ancho_bar)
         .attr("height", function (d) { return Yescala(d.value.count); })
         .attr("x", function (d, i) { return (margenHor + i * ancho_bar) })
         .attr("y", function (d) { return (sizeChart[1] - Yescala(d.value.count) - margenVer) });
    }

    CardinalRect.each(function (d) { d.selected = true; });

    d3.select(targetDiv).append("g")
          .attr("class", "Xaxis")
          .attr("transform", "translate(0," + (sizeChart[1] - margenVer) + ")")
          .call(Axis);

    var Axis_Yescala = d3.scale.linear().domain([0, Ymax]).range([sizeChart[1] - margenVer, 0.5 * margenVer]),
       Y_Axis = d3.svg.axis().scale(Axis_Yescala).orient("left").ticks(4);

    d3.select(targetDiv).append("g")
        .attr("class", "Yaxis")
        .attr("transform", "translate(" + margenHor + ", 0)")
        .call(Y_Axis);

    //Si es un histograma con datos continuos, o dependientes entre si,creo un brush. En caso de que las barras de los histogramas sean de grupos independientes, la seleccion ...
    // ... se hace mediante la funcion click
    if (ordinal == 0) {

        var Hbrush = d3.svg.brush()
                             .x(Xescala)
                            // .extent(Xmin_max)
                             .on("brush", Brushed);

        d3.select(targetDiv).append("g").attr("class", ".brush").call(Hbrush)
        .selectAll("rect").attr("transform", "translate(0," + 0.5 * margenVer + ")").attr("height", sizeChart[1] - (margenVer * 1.5));

        d3.select(targetDiv).select("g.resize.w").append("image")
        .attr("width", 15)
        .attr("height", 100)
        .attr("y", (sizeChart[1] / 2 - 50))
        .attr("x", -10)
        .attr("xlink:href", 'left-handle.png');

        d3.select(targetDiv).select("g.resize.e").append("image")
        .attr("width", 15)
        .attr("height", 100)
        .attr("y", (sizeChart[1] / 2 - 50))
        .attr("x", -4)
        .attr("xlink:href", 'right-handle.png');

        d3.selectAll("g.resize > rect").style("visibility", "visible");

        function Brushed() {
            var e = Hbrush.extent();
            selected = Xescala.domain().filter(function (d) { return (e[0] <= Xescala(d)) && (Xescala(d) <= e[1]) });
            var brushExtent = d3.extent(selected, function (d) { return d });
            brushExtent[1] = brushExtent[1] + 0.001;

            dimension.filter([brushExtent[0], brushExtent[1]]);
            var grupo = d3.select(targetDiv).selectAll("rect.histobar");
            grupo.each(function (d) {
                if (d.key >= brushExtent[0] && d.key <= brushExtent[1]) {
                    d.selected = true;
                }
                else {
                    d.selected = false;
                }
            });
            grupo.style("fill", function (d) {
                if (d.key >= brushExtent[0] && d.key <= brushExtent[1]) {
                    return "#58a9ea";
                }
                else {
                    return "gray";
                }
            });

            if (brushExtent[0] == Xmin_max[0] && brushExtent[1] == Xmin_max[1]) { dimension.filter(null) }  // elimina un pequeño bug en los limites del brush
            if (brushExtent[0] === undefined) {
                dimension.filter(null);

                grupo.each(function (d) {
                    d.selected = true;
                });
                d3.select(targetDiv).selectAll("rect.histobar").style("fill", "#58a9ea");
            }

            update();
        }
    }
    if (ordinal == 1) {
        CardinalRect.each(function (d) { d.selected = true });
        CardinalRect.on("click", filtrar);

        function filtrar(d) { 
            if (aux == 0 || d.selected == 0) {
                dimension.filter(d.key); console.log(this, d.key)
                CardinalRect.each(function (p) { p.selected = false });
                d.selected = true;
               // CardinalRect.style("fill", function (p) { return p.selected == true ? "#58a9ea" : "gray" });
                aux++;
            }
            else {
                dimension.filter(null);
                CardinalRect.each(function (p) { p.selected = true; });
                          //  .style("fill", function (p) { return p.selected == true ? "#58a9ea" : "gray" });
                aux--;
            }
            update();
        }
    }
};

//FUNCION PARA ACTUALIZAR LOS HISTOGRAMAS   
function update() {
    if (reduceOK == 0) {
        // console.log("Los grupos NO llevan reduce")

        for (i = 0; i < 7; i++) {
            if (i < 2) {
                Ymax[i] = d3.max(dimensionGroups[i], function (d) { if (d.selected == true) return d.value });
                Yescala = d3.scale.linear().domain([0, Ymax[i]]).range([0, size[1] - 2 * margenVer1]);
                d3.select(divsGroup[i]).selectAll("rect.histobar")
                .attr("height", function (d) {
                    if (d.selected) { return Yescala(d.value); }
                    else { return 0; }
                })
                .attr("y", function (d) { return (size[1] - Yescala(d.value) - margenVer1) });

                var Axis_Yescala = d3.scale.linear().domain([0, Ymax[i]]).range([size[1] - margenVer1, margenVer1]);
                Y_Axis[i] = d3.svg.axis().scale(Axis_Yescala).orient("left").ticks(4);
                d3.select(divsGroup[i]).selectAll(".Yaxis").call(Y_Axis[i]);
            }
            else {
                Ymax[i] = d3.max(dimensionGroups[i], function (d) { if (d.selected == true) return d.value });
                Yescala = d3.scale.linear().domain([0, Ymax[i]]).range([0, size2[1] - 2 * margenVer2]);
                d3.select(divsGroup[i]).selectAll("rect.histobar")
                .attr("height", function (d) {
                    if (d.selected) { return Yescala(d.value); }
                    else { return 0; }
                })
                .attr("y", function (d) { return (size2[1] - Yescala(d.value) - margenVer2) });

                var Axis_Yescala = d3.scale.linear().domain([0, Ymax[i]]).range([size2[1] - margenVer2, margenVer2]);
                Y_Axis[i] = d3.svg.axis().scale(Axis_Yescala).orient("left").ticks(4);
                d3.select(divsGroup[i]).selectAll(".Yaxis").call(Y_Axis[i]);
            }
        }
    }
    else {
        // console.log("Los grupos llevan reduce")

        if (aggregatedPrice == 0 && aggregatedEnergy == 0 && aggregatedCO2 == 0) {
            //   console.log("Update sin pulsar el boton de aggregated")
            for (i = 0; i < 7; i++) {
                if (i < 2) {
                    Ymax[i] = d3.max(dimensionGroups[i], function (d) { if (d.selected == true) return d.value.count });
                    Yescala = d3.scale.linear().domain([0, Ymax[i]]).range([0, size[1] - 2 * margenVer1]);
                    d3.select(divsGroup[i]).selectAll("rect.histobar")
                    .attr("height", function (d) {
                        if (d.selected) { return Yescala(d.value.count); }
                        else { return 0; }
                    })
                    .attr("y", function (d) { return (size[1] - Yescala(d.value.count) - margenVer1) });

                    var Axis_Yescala = d3.scale.linear().domain([0, Ymax[i]]).range([size[1] - margenVer1, margenVer1]);
                    Y_Axis[i] = d3.svg.axis().scale(Axis_Yescala).orient("left").ticks(4);
                    d3.select(divsGroup[i]).selectAll(".Yaxis").call(Y_Axis[i]);
                }
                else {
                    Ymax[i] = d3.max(dimensionGroups[i], function (d) { if (d.selected == true) return d.value.count });
                    Yescala = d3.scale.linear().domain([0, Ymax[i]]).range([0, size2[1] - 2 * margenVer2]);
                    d3.select(divsGroup[i]).selectAll("rect.histobar")
                    .attr("height", function (d) {
                        if (d.selected) { return Yescala(d.value.count); }
                        else { return 0; }
                    })
                    .attr("y", function (d) { return (size2[1] - Yescala(d.value.count) - margenVer2) });

                    var Axis_Yescala = d3.scale.linear().domain([0, Ymax[i]]).range([size2[1] - margenVer2, margenVer2]);
                    Y_Axis[i] = d3.svg.axis().scale(Axis_Yescala).orient("left").ticks(4);
                    d3.select(divsGroup[i]).selectAll(".Yaxis").call(Y_Axis[i]);
                }
            }
            d3.select("#MaxValues")
            .text("");
            d3.select("#EnergyAndCost")
            .text("");
        }
        else { //Camino al pulsar algun de los botones de agregacion

            //Inicializo la variable para que vuelva a sumar valores desde cero
            TotalKWh = 0;
            totalEuros = 0;
            TotalCO2 = 0;

            for (i = 0; i < dimensionGroups[0].length; i++) {
                TotalKWh += dimensionGroups[0][i].value.totalKwhGroup;
            }

            for (i = 0; i < dimensionGroups[6].length; i++) {
                if (dimensionGroups[6][i].selected == true) {
                    totalEuros += dimensionGroups[6][i].value.price;
                }
            }
            euroKwh = totalEuros / TotalKWh;
            TotalCO2 = TotalKWh * 0.65;

            if (aggregatedPrice == 1) {
                console.log("Update PULSANDO el boton de aggregated Price")

                for (i = 0; i < 7; i++) {
                    if (i < 2) {
                        Ymax[i] = d3.max(dimensionGroups[i], function (d) { if (d.selected == true) return d.value.price });
                        Yescala = d3.scale.linear().domain([0, Ymax[i]]).range([0, size[1] - 2 * margenVer1]);
                        d3.select(divsGroup[i]).selectAll("rect.histobar")
                        .attr("height", function (d) {
                            if (d.selected) { return Yescala(d.value.price); }
                            else { return 0; }
                        })
                        .attr("y", function (d) { return (size[1] - Yescala(d.value.price) - margenVer1) });

                        var Axis_Yescala = d3.scale.linear().domain([0, Ymax[i]]).range([size[1] - margenVer1, margenVer1]);
                        Y_Axis[i] = d3.svg.axis().scale(Axis_Yescala).orient("left").ticks(4);
                        d3.select(divsGroup[i]).selectAll(".Yaxis").call(Y_Axis[i]);
                    }
                    else {
                        if (i == 2) {
                            Ymax[i] = d3.max(dimensionGroups[i], function (d) { if (d.selected == true) return d.value.avg });
                            Yescala = d3.scale.linear().domain([0, Ymax[i]]).range([0, size2[1] - 2 * margenVer2]);
                            d3.select(divsGroup[i]).selectAll("rect.histobar")
                            .attr("height", function (d) {
                                if (d.selected) { return Yescala(d.value.avg); }
                                else { return 0; }
                            })
                            .attr("y", function (d) { return (size2[1] - Yescala(d.value.avg) - margenVer2) });

                            var Axis_Yescala = d3.scale.linear().domain([0, Ymax[i]]).range([size2[1] - margenVer2, margenVer2]);
                            Y_Axis[i] = d3.svg.axis().scale(Axis_Yescala).orient("left").ticks(4);
                            d3.select(divsGroup[i]).selectAll(".Yaxis").call(Y_Axis[i]);
                        }
                        else {
                            if (i == 3) {
                                Ymax[i] = d3.max(dimensionGroups[i], function (d) { if (d.selected == true) return d.value.avgWeekday });
                                Yescala = d3.scale.linear().domain([0, Ymax[i]]).range([0, size2[1] - 2 * margenVer2]);
                                d3.select(divsGroup[i]).selectAll("rect.histobar")
                                .attr("height", function (d) {
                                    if (d.selected) { return Yescala(d.value.avgWeekday); }
                                    else { return 0; }
                                })
                                .attr("y", function (d) { return (size2[1] - Yescala(d.value.avgWeekday) - margenVer2) });

                                var Axis_Yescala = d3.scale.linear().domain([0, Ymax[i]]).range([size2[1] - margenVer2, margenVer2]);
                                Y_Axis[i] = d3.svg.axis().scale(Axis_Yescala).orient("left").ticks(4);
                                d3.select(divsGroup[i]).selectAll(".Yaxis").call(Y_Axis[i]);
                            }
                            else {
                                Ymax[i] = d3.max(dimensionGroups[i], function (d) { if (d.selected == true) return d.value.price });
                                Yescala = d3.scale.linear().domain([0, Ymax[i]]).range([0, size2[1] - 2 * margenVer2]);
                                d3.select(divsGroup[i]).selectAll("rect.histobar")
                                .attr("height", function (d) {
                                    if (d.selected) { return Yescala(d.value.price); }
                                    else { return 0; }
                                })
                                .attr("y", function (d) { return (size2[1] - Yescala(d.value.price) - margenVer2) });

                                var Axis_Yescala = d3.scale.linear().domain([0, Ymax[i]]).range([size2[1] - margenVer2, margenVer2]);
                                Y_Axis[i] = d3.svg.axis().scale(Axis_Yescala).orient("left").ticks(4);
                                d3.select(divsGroup[i]).selectAll(".Yaxis").call(Y_Axis[i]);
                            }
                        }
                    }
                }
                //Escribo los valores maximos de las graficas que me interesen
                d3.select("#MaxValues")
                .text(" Maximun price values - by Hour: " + parseFloat((Ymax[2]).toFixed(2)) + "€/h, Weekday: " + parseFloat((Ymax[3]).toFixed(2))
                        + "€/day, Month: " + parseFloat((Ymax[4]).toFixed(2)) + "€/month, Building: " + parseFloat((Ymax[6]).toFixed(2))
                        + "€/year.");
                d3.select("#EnergyAndCost")
                .text(" Total cost: " + parseFloat((totalEuros).toFixed(2)) + "€, Price of Kwh: " + parseFloat(euroKwh.toFixed(4)) + "€");
            }
            else {
                if (aggregatedEnergy == 1) {
                   // console.log("Update PULSANDO el boton de aggregated Energy")

                    for (i = 0; i < 7; i++) {
                        if (i < 2) {
                            Ymax[i] = d3.max(dimensionGroups[i], function (d) { if (d.selected == true) return d.value.totalKwhGroup });
                            Yescala = d3.scale.linear().domain([0, Ymax[i]]).range([0, size[1] - 2 * margenVer1]);
                            d3.select(divsGroup[i]).selectAll("rect.histobar")
                            .attr("height", function (d) {
                                if (d.selected) { return Yescala(d.value.totalKwhGroup); }
                                else { return 0; }
                            })
                            .attr("y", function (d) { return (size[1] - Yescala(d.value.totalKwhGroup) - margenVer1) });

                            var Axis_Yescala = d3.scale.linear().domain([0, Ymax[i]]).range([size[1] - margenVer1, margenVer1]);
                            Y_Axis[i] = d3.svg.axis().scale(Axis_Yescala).orient("left").ticks(4);
                            d3.select(divsGroup[i]).selectAll(".Yaxis").call(Y_Axis[i]);
                        }
                        else {
                            if (i == 2) {
                                Ymax[i] = d3.max(dimensionGroups[i], function (d) { if (d.selected == true) return d.value.avgEnergy });
                                Yescala = d3.scale.linear().domain([0, Ymax[i]]).range([0, size2[1] - 2 * margenVer2]);
                                d3.select(divsGroup[i]).selectAll("rect.histobar")
                                .attr("height", function (d) {
                                    if (d.selected) { return Yescala(d.value.avgEnergy); }
                                    else { return 0; }
                                })
                                .attr("y", function (d) { return (size2[1] - Yescala(d.value.avgEnergy) - margenVer2) });

                                var Axis_Yescala = d3.scale.linear().domain([0, Ymax[i]]).range([size2[1] - margenVer2, margenVer2]);
                                Y_Axis[i] = d3.svg.axis().scale(Axis_Yescala).orient("left").ticks(4);
                                d3.select(divsGroup[i]).selectAll(".Yaxis").call(Y_Axis[i]);
                            }
                            else {
                                if (i == 3) {
                                    Ymax[i] = d3.max(dimensionGroups[i], function (d) { if (d.selected == true) return d.value.avgWeekdayEnergy });
                                    Yescala = d3.scale.linear().domain([0, Ymax[i]]).range([0, size2[1] - 2 * margenVer2]);
                                    d3.select(divsGroup[i]).selectAll("rect.histobar")
                                    .attr("height", function (d) {
                                        if (d.selected) { return Yescala(d.value.avgWeekdayEnergy); }
                                        else { return 0; }
                                    })
                                    .attr("y", function (d) { return (size2[1] - Yescala(d.value.avgWeekdayEnergy) - margenVer2) });

                                    var Axis_Yescala = d3.scale.linear().domain([0, Ymax[i]]).range([size2[1] - margenVer2, margenVer2]);
                                    Y_Axis[i] = d3.svg.axis().scale(Axis_Yescala).orient("left").ticks(4);
                                    d3.select(divsGroup[i]).selectAll(".Yaxis").call(Y_Axis[i]);
                                }
                                else {
                                    if (i == 4) {
                                        Ymax[i] = d3.max(dimensionGroups[i], function (d) { if (d.selected == true) return d.value.totalKwhGroup });
                                        Yescala = d3.scale.linear().domain([0, Ymax[i]]).range([0, size2[1] - 2 * margenVer2]);
                                        d3.select(divsGroup[i]).selectAll("rect.histobar")
                                        .attr("height", function (d) {
                                            if (d.selected) { return Yescala(d.value.totalKwhGroup); }
                                            else { return 0; }
                                        })
                                        .attr("y", function (d) { return (size2[1] - Yescala(d.value.totalKwhGroup) - margenVer2) });

                                        var Axis_Yescala = d3.scale.linear().domain([0, Ymax[i]]).range([size2[1] - margenVer2, margenVer2]);
                                        Y_Axis[i] = d3.svg.axis().scale(Axis_Yescala).orient("left").ticks(4);
                                        d3.select(divsGroup[i]).selectAll(".Yaxis").call(Y_Axis[i]);
                                    }
                                    else {
                                        Ymax[i] = d3.max(dimensionGroups[i], function (d) { if (d.selected == true) return d.value.totalKwhGroup });
                                        Yescala = d3.scale.linear().domain([0, Ymax[i]]).range([0, size2[1] - 2 * margenVer2]);
                                        d3.select(divsGroup[i]).selectAll("rect.histobar")
                                        .attr("height", function (d) {
                                            if (d.selected) { return Yescala(d.value.totalKwhGroup); }
                                            else { return 0; }
                                        })
                                        .attr("y", function (d) { return (size2[1] - Yescala(d.value.totalKwhGroup) - margenVer2) });

                                        var Axis_Yescala = d3.scale.linear().domain([0, Ymax[i] / 1000]).range([size2[1] - margenVer2, margenVer2]);
                                        Y_Axis[i] = d3.svg.axis().scale(Axis_Yescala).orient("left").ticks(4);
                                        d3.select(divsGroup[i]).selectAll(".Yaxis").call(Y_Axis[i]);
                                    }
                                }
                            }
                        }
                    }
                    d3.select("#MaxValues")
                        .text(" Max. energy values by Hour: " + parseFloat((Ymax[2]).toFixed(1)) + "Kwh/h, Weekday: " + parseFloat((Ymax[3]).toFixed(1))
                                + "Kwh/day, Month: " + parseFloat((Ymax[4] / 1000).toFixed(1)) + "Mwh/month, Building: " + parseFloat((Ymax[6] / 1000).toFixed(1))
                                + "Mwh/year.");
                    d3.select("#EnergyAndCost")
                    .text(" Total Energy: " + parseFloat((TotalKWh / 1000).toFixed(2)) + "Mwh");
                }

                else {
                    console.log("Update PULSANDO el boton de CO2")

                    for (i = 0; i < 7; i++) {
                        if (i < 2) {
                            Ymax[i] = d3.max(dimensionGroups[i], function (d) { if (d.selected == true) return d.value.totalCO2Group });
                            Yescala = d3.scale.linear().domain([0, Ymax[i]]).range([0, size[1] - 2 * margenVer1]);
                            d3.select(divsGroup[i]).selectAll("rect.histobar")
                            .attr("height", function (d) {
                                if (d.selected) { return Yescala(d.value.totalCO2Group); }
                                else { return 0; }
                            })
                            .attr("y", function (d) { return (size[1] - Yescala(d.value.totalCO2Group) - margenVer1) });

                            var Axis_Yescala = d3.scale.linear().domain([0, Ymax[i]]).range([size[1] - margenVer1, margenVer1]);
                            Y_Axis[i] = d3.svg.axis().scale(Axis_Yescala).orient("left").ticks(4);
                            d3.select(divsGroup[i]).selectAll(".Yaxis").call(Y_Axis[i]);
                        }
                        else {
                            if (i == 2) {
                                Ymax[i] = d3.max(dimensionGroups[i], function (d) { if (d.selected == true) return d.value.avgCO2 });
                                Yescala = d3.scale.linear().domain([0, Ymax[i]]).range([0, size2[1] - 2 * margenVer2]);
                                d3.select(divsGroup[i]).selectAll("rect.histobar")
                                .attr("height", function (d) {
                                    if (d.selected) { return Yescala(d.value.avgCO2); }
                                    else { return 0; }
                                })
                                .attr("y", function (d) { return (size2[1] - Yescala(d.value.avgCO2) - margenVer2) });

                                var Axis_Yescala = d3.scale.linear().domain([0, Ymax[i]]).range([size2[1] - margenVer2, margenVer2]);
                                Y_Axis[i] = d3.svg.axis().scale(Axis_Yescala).orient("left").ticks(4);
                                d3.select(divsGroup[i]).selectAll(".Yaxis").call(Y_Axis[i]);
                            }
                            else {
                                if (i == 3) {
                                    Ymax[i] = d3.max(dimensionGroups[i], function (d) { if (d.selected == true) return d.value.avgCO2Weekday });
                                    Yescala = d3.scale.linear().domain([0, Ymax[i]]).range([0, size2[1] - 2 * margenVer2]);
                                    d3.select(divsGroup[i]).selectAll("rect.histobar")
                                    .attr("height", function (d) {
                                        if (d.selected) { return Yescala(d.value.avgCO2Weekday); }
                                        else { return 0; }
                                    })
                                    .attr("y", function (d) { return (size2[1] - Yescala(d.value.avgCO2Weekday) - margenVer2) });

                                    var Axis_Yescala = d3.scale.linear().domain([0, Ymax[i]]).range([size2[1] - margenVer2, margenVer2]);
                                    Y_Axis[i] = d3.svg.axis().scale(Axis_Yescala).orient("left").ticks(4);
                                    d3.select(divsGroup[i]).selectAll(".Yaxis").call(Y_Axis[i]);
                                }
                                else {
                                    if (i == 4) {
                                        Ymax[i] = d3.max(dimensionGroups[i], function (d) { if (d.selected == true) return d.value.totalCO2Group });
                                        Yescala = d3.scale.linear().domain([0, Ymax[i]]).range([0, size2[1] - 2 * margenVer2]);
                                        d3.select(divsGroup[i]).selectAll("rect.histobar")
                                        .attr("height", function (d) {
                                            if (d.selected) { return Yescala(d.value.totalCO2Group); }
                                            else { return 0; }
                                        })
                                        .attr("y", function (d) { return (size2[1] - Yescala(d.value.totalCO2Group) - margenVer2) });

                                        var Axis_Yescala = d3.scale.linear().domain([0, Ymax[i]]).range([size2[1] - margenVer2, margenVer2]);
                                        Y_Axis[i] = d3.svg.axis().scale(Axis_Yescala).orient("left").ticks(4);
                                        d3.select(divsGroup[i]).selectAll(".Yaxis").call(Y_Axis[i]);
                                    }
                                    else {
                                        Ymax[i] = d3.max(dimensionGroups[i], function (d) { if (d.selected == true) return d.value.totalCO2Group });
                                        Yescala = d3.scale.linear().domain([0, Ymax[i]]).range([0, size2[1] - 2 * margenVer2]);
                                        d3.select(divsGroup[i]).selectAll("rect.histobar")
                                        .attr("height", function (d) {
                                            if (d.selected) { return Yescala(d.value.totalCO2Group); }
                                            else { return 0; }
                                        })
                                        .attr("y", function (d) { return (size2[1] - Yescala(d.value.totalCO2Group) - margenVer2) });

                                        var Axis_Yescala = d3.scale.linear().domain([0, Ymax[i] / 1000]).range([size2[1] - margenVer2, margenVer2]);
                                        Y_Axis[i] = d3.svg.axis().scale(Axis_Yescala).orient("left").ticks(4);
                                        d3.select(divsGroup[i]).selectAll(".Yaxis").call(Y_Axis[i]);
                                    }
                                }
                            }
                        }
                    }
                    d3.select("#MaxValues")
                        .text(" Max. CO2 emision values by Hour: " + parseFloat((Ymax[2]).toFixed(1)) + " Kg/h, Weekday: " + parseFloat((Ymax[3]).toFixed(1))
                                + " Kg/day , Month: " + parseFloat((Ymax[4] / 1000).toFixed(1)) + " Tn/month, Building: " + parseFloat((Ymax[6] / 1000).toFixed(1))
                                + " Tn/year.");
                    d3.select("#EnergyAndCost")
                    .text(" Total Tn CO2: " + parseFloat(TotalCO2 / 1000).toFixed(2));
                }
            }
        }

        $('#svg_scatter').empty();
        Crear_Histo2D(bidi, bidi_grupo, '#svg_scatter');

        if (sliderON == 0) {
            $('#tabla').empty();
            Crear_Spreadsheet(activa, "#tabla", 1);
        }
    }
}

//FUNCION PARA CREAR UNA LISTA
function Crear_Spreadsheet(dimension, target_Div, max) {
    var sizeChart = canvasSize(target_Div);

    if (max == 1) { var matriz_datos = dimension.top(8); }
    else { var matriz_datos = dimension.bottom(8); }
    
    var x = dimension.top(1);                   
    var keyValues = d3.keys(x[0]);

    ancho_col = sizeChart[0] / keyValues.length;

    //Creo el encabezado
    d3.select(target_Div)
    .append("div")
    .attr("class", "head_row")
    .selectAll("div.head_data")
    .data(keyValues)
    .enter()
    .append("div")
    .attr("class", "head_data")
    .html(function (d) { return d })
    .style("left", function (d, i) { return (i * ancho_col) + "px"; });

    //Creo el div que contendrá todas las filas
    d3.select(target_Div)
    .append("div")
    .attr("class", "list");

    //Creo las filas
    d3.select("div.list")
    .selectAll("div.datarow")
    .data(matriz_datos, function (d) { return d.Active })
    .enter()
    .append("div")
    .attr("class", "datarow")
    .style("top", function (d, i) { return (i * 30) + "px"; });

    //Creo las columnas
    d3.selectAll("div.datarow")
    .selectAll("div.data")
    .data(function (d) { return d3.entries(d) })
    .enter()
    .append("div")
    .attr("class", "data")
    .html(function (d) { return d.value })
    .style("left", function (d, i, j) { return (i * ancho_col) + "px"; });
};

//FUNCION PARA CREAR LOS CONTROLES DE LA SPREADSHEET 
function Crear_controles() {
    auxActiva = auxReactiva = auxAparente = auxCosPhi = auxHora = 1;

    //Calculo la relacion de aspecto de la pantalla y ajusto los margenes para un correcto visionado ( solo apto para relaciones de aspecto 4/3 y 3/2 )
    if (((screen.width / screen.height) >= 1.3) && ((screen.width / screen.height) <= 1.4)) {
        d3.selectAll("margen").attr("height", "10%");
    }

   var DivButtons = d3.select("#controls").append("div").attr("id", "buttons");
   DivButtons.append("button").on("click", ordenarActiva).html("Active");
  //  d3.select("#controls").append("button").on("click", ordenarReactiva).html("Reactiva");
   // d3.select("#controls").append("button").on("click", ordenarAparente).html("Aparente");
   DivButtons.append("button").on("click", ordenarCosPhi).html("Power Factor");
    // d3.select("#controls").append("button").on("click", ordenarHora).html("Hora");
   DivButtons.append("button").html("Price").on("click", agregadosPrice);
   DivButtons.append("button").html("Energy").on("click", agregadosEnergy);
   DivButtons.append("button").html("CO2").on("click", agregadosCO2);
   DivButtons.append("button").html("Modify tariff").on("click", modifytariff);
   DivButtons.append("button").html("Back to Top").on("click", function () {
        $(window).scrollTop($('#title').offset().top);
    });

   // d3.select("#controls").append("textbox"); //Creo un textbox para, posteriormente, añadir los valores maximos en €

    d3.select("#description").append("button").html("Begin!").on("click", function () {
        $(window).scrollTop($('#Div_scatter').offset().top);
    });

    d3.select("#description").append("button").html("...with spreadsheet").on("click", function () {
        $(window).scrollTop($('#Div_activa').offset().top+20);
    });
    //Añado los divs para los datos de interes que muestro al dar al boton de agregrate
    var DatosDeInteres = d3.select("#controls").append("div").attr("id", "GeneralValues");
    DatosDeInteres.append("div").attr("id", "MaxValues");
    DatosDeInteres.append("div").attr("id", "EnergyAndCost");
}

//FUNCION PARA MOSTRAR LOS VALORES MAXIMOS DE CIERTOS HISTOGRAMAS
function Crear_valoresMax(target_Div) {
    //console.log("crear valoresMAx", Ymax);
    d3.select(target_Div).append("textbox")
        .text(" - Maximun price values - by Hour: " + Ymax[2] + ", Weekday: " + Ymax[3] + ", Month: " + Ymax[4] + ", Building: " + Ymax[6] + "");
}

//FUNCION PARA CREAR  LOS SLIDERS O LA TABLA SEGUN SE PULSE EL BOTON
function modifytariff() {

        $(window).scrollTop($('#Div_activa').offset().top + 20);

    $('#tabla').empty();

    if (sliderON == 0) {
        crear_slider("#tabla", hours)
        sliderON = 1;
 
    }
    else {
        Crear_Spreadsheet(activa, "#tabla", auxActiva);
        sliderON = 0;
    }
}

//FUNCION PARA CREAR UN GRUPO DE SLIDERS QUE OCUPEN TODO EL ANCHO DE LA PAGINA
function crear_slider(target_Div, group) {

    var sizeChart = canvasSize(target_Div);
    sliderWidth = sizeChart[0] / 24;

    slider_Group = group.all();
    var x = slider_Group.length;

    d3.select(target_Div).append("h4").text("Configure your own electricity tariff");
    d3.select(target_Div).append("p").text("These sliders offers the posibility of modify the price, in kWh/€, of each hour independently... ");


    for (i = 0; i < x; i++) {

        slideValueOriginal[i] = parseFloat(slider_Group[i].value.hourPrice);

             slider[i] = d3.slider().min(0.04).max(0.12)
            .value(slideValueOriginal[i])
            .orientation("vertical")
            .axis(d3.svg.axis().orient("right"))
            .on("slide", slideFunc)
            .on("slideend", slideFunc);
 
        var sl_Block = d3.select(target_Div).append("div").attr("class", "sliderBlock")
                .style("left", function () { return (i * sliderWidth) + "px"; });

        sl_Block.append("text").text("Hour: " + i).attr("class", "p");

        sl_Block.append("div").attr("id", "slide" + i + "")
           .call(slider[i]);

        sl_Block.append("div")
                .attr("class", "slideValue")
                .attr("id", "slideValue" + i + "")
                .append("text")
                 .attr("x", 5)
                 .attr("y", 20)
                 .text(function (d) { return parseFloat(slider_Group[i].value.hourPrice).toFixed(3) + " €"; });

        sl_Block.append("button")
                  .attr("class", "slideButton")
                  .attr("id", "slideButton" + i + "")
                  .text("reset")
                  .on("click", resetPrice);

    }
    slideValue = slideValueOriginal.slice();
}

//FUNCION SLIDE
function slideFunc(evt, value) {
   // console.log("funcion slide")
    slideAux = 1;
    if (reset == 0) {
        d3.select("#" + event.target.nextElementSibling.id + "").select("text").text(parseFloat(value).toFixed(3) + '€');

        var x = event.target.nextElementSibling.id;
        slidePosition = parseInt(x.substr(10));

        slideValue[slidePosition] = value;

        var Lenght = dataPrueba.length;

        for (i = 0; i < Lenght; i++) {
            if (dataPrueba[i].Hour == slidePosition) {
                dataPrueba[i].Price = slideValue[slidePosition];
            };
        };
        Crear_Dimensiones(dataPrueba);        
        EliminarHistos();
        Crear_Histogramas();

        update();
    }
    else {
        reset = 0;
    }
};

//FUNCION PARA RESETEAR EL VALOR DE CADA SLIDE Y PONERLO POR DEFECTO 
function resetPrice() {
    reset = 1;
    var x = event.target.id;
    var bottonPosition = parseInt(x.substr(11)); 
    slideValue[bottonPosition] = slideValueOriginal[bottonPosition];

    d3.select("#slideValue" + bottonPosition + "").select("text").text(parseFloat(slideValue[bottonPosition]).toFixed(3) + '€');

    var originalValue = slideValue[bottonPosition];
    slider[bottonPosition].value(originalValue); console.log("slider.value", slider[bottonPosition], originalValue)

    var Lenght = dataPrueba.length;

    for (i = 0; i < Lenght; i++) {
        if (dataPrueba[i].Hour == bottonPosition) {
            dataPrueba[i].Price = slideValueOriginal[bottonPosition];
        };
    };
    Crear_Dimensiones(dataPrueba);
    EliminarHistos()
    Crear_Histogramas();

    update();
    
}

// FUNCIONES PARA ORDENAR POR UN DETERMINADO ATRIBUTO
function ordenarActiva() { 
   
    $('#tabla').empty();
    Crear_Spreadsheet(activa, "#tabla", auxActiva);

    if (auxActiva == 1) { auxActiva = 0; }
    else { auxActiva = 1; }
}
function ordenarReactiva() {

    $('#tabla').empty();
    Crear_Spreadsheet(reactiva, "#tabla", auxReactiva);

    if (auxReactiva == 1) { auxReactiva = 0; }
    else { auxReactiva = 1; }
}
function ordenarAparente() {

    $('#tabla').empty();
    Crear_Spreadsheet(aparente, "#tabla", auxAparente);

    if (auxAparente == 1) { auxAparente = 0; }
    else { auxAparente = 1; }
}
function ordenarCosPhi() {

    $('#tabla').empty();
    Crear_Spreadsheet(powerFactor, "#tabla", auxCosPhi);

    if (auxCosPhi == 1) { auxCosPhi = 0; }
    else { auxCosPhi = 1; }

}
function ordenarHora() {

    $('#tabla').empty();
    Crear_Spreadsheet(hour, "#tabla", auxHora);

    if (auxHora == 1) { auxHora = 0; }
    else { auxHora = 1; }

}

//FUNCIONES PARA CREAR 2 GRUPOS A PARTIR DE UNA MATRIZ DE DATOS Y, POSTERIORMENTE, AGRUPARLOS EN TODAS SUS COMBINACIONES POSIBLES
function CrearGrupos(matrizGeneral) {
    GrupoActivas = [];
    GrupoCos = [];
    var grA = [];
    var grPF = [];

    for (i = 0; i < matrizGeneral.length; i++) {
        grA.push(Math.floor(matrizGeneral[i].Active / 6) * 6);
        grPF.push(Math.floor(matrizGeneral[i].cosPhi * 35) / 35);
        if (GrupoActivas.indexOf(grA[i]) ==-1){
            GrupoActivas.push(grA[i]);
        }
        if (GrupoCos.indexOf(grPF[i]) == -1) {
            GrupoCos.push(grPF[i]);
        } 
    } 
}
function agruparCombinaciones(grupo1, grupo2, matrizGeneral) {

     pos = [];
     Pgrupos = grupo1.length;  
     PFgrupos = grupo2.length; 

    grupo_contador = d3.range(Pgrupos * PFgrupos); 
    
    var newArr = [];
    while (grupo_contador.length) { newArr.push(grupo_contador.splice(0, Pgrupos)); }
    grupo_contador = newArr;
                                  
    
    for (i = 0; i < matrizGeneral.length; i++) {
        for (k = 0; k < PFgrupos; k++) {
            for (j = 0; j < Pgrupos; j++) {
                if ((matrizGeneral[i].cosPhi >= grupo2[k]) && (matrizGeneral[i].cosPhi < (grupo2[k] + 0.056)) &&
                    (matrizGeneral[i].Active >= grupo1[j]) && (matrizGeneral[i].Active < (grupo1[j] + 6))) {

                    matrizGeneral[i].Group = grupo_contador[k][j];
                }
            }
        }
    }
    for (k = 0; k < PFgrupos; k++) {
        for (j = 0; j < Pgrupos; j++) {
            pos[k * Pgrupos + j] = [grupo1[j],grupo2[k]]
            }
        }
}

//FUNCION PARA PASAR A DATOS AGREGADOS DE COSTE O ENERGIA
function agregadosPrice(grupos) {

    if (aggregatedPrice == 0 || (aggregatedEnergy == 1 || aggregatedCO2 == 1)) {
        aggregatedPrice = 1;
        aggregatedEnergy = 0;
        aggregatedCO2 = 0;

    //borro lo anterior que estuviera escrito (por si se viene directamente desde "Aggregated Energy"
        prueba22 = d3.selectAll("div.title").select("h4");
        prueba22.select("text").remove();
        d3.select("#controls").selectAll("textbox")
            .text("");

        titleGroup = d3.selectAll("div.title").select("h4").append("text").text(" (cost in €)"); 
    }
    else {
        aggregatedPrice = 0;
        prueba22 = d3.selectAll("div.title").select("h4");
        prueba22.select("text").remove();
        d3.select("#controls").selectAll("textbox")
            .text("");
    }
    update();
}
function agregadosEnergy(grupos) {

    if (aggregatedEnergy == 0 || (aggregatedPrice == 1 || aggregatedCO2 == 1)) {
        aggregatedEnergy = 1;
        aggregatedPrice = 0;
        aggregatedCO2 = 0;

        //borro lo anterior que estuviera escrito (por si se viene directamente desde "Aggregated Price"
        prueba22 = d3.selectAll("div.title").select("h4");
        prueba22.select("text").remove();
        d3.select("#controls").selectAll("textbox")
            .text("");

        titleGroup = d3.selectAll("div.title").select("h4").append("text").text(" (in Kwh)");
        d3.select("#titleBuilding").select("text").text(" (in Mwh)");
        d3.select("#titleHoliday").select("text").text(" (in Mwh)");

    }
    else {
        aggregatedEnergy = 0;
        prueba22 = d3.selectAll("div.title").select("h4");
        prueba22.select("text").remove();
        d3.select("#controls").selectAll("textbox")
            .text("");
    }
    update();
}
function agregadosCO2(grupos) {

    if (aggregatedCO2 == 0 || (aggregatedPrice == 1 || aggregatedEnergy == 1)) {
        aggregatedCO2 = 1;
        aggregatedPrice = 0;
        aggregatedEnergy = 0; 

        //borro lo anterior que estuviera escrito (por si se viene directamente desde "Aggregated Price"
        prueba22 = d3.selectAll("div.title").select("h4");
        prueba22.select("text").remove();
        d3.select("#controls").selectAll("textbox")
            .text("");

        titleGroup = d3.selectAll("div.title").select("h4").append("text").text(" (in Kg CO2)");
        d3.select("#titleBuilding").select("text").text(" (in Tn CO2)");
        d3.select("#titleHoliday").select("text").text(" (in Tn CO2)");
    }
    else {
        aggregatedCO2 = 0;
        prueba22 = d3.selectAll("div.title").select("h4");
        prueba22.select("text").remove();
        d3.select("#controls").selectAll("textbox")
            .text("");
    }
    update();
}
//FUNCIONES REDUCE
function reduceAdd(p, v) {
    ++p.count;
    p.hourPrice = v.Price;
    p.totalKwhGroup += v.Active;
    p.totalCO2Group  = p.totalKwhGroup * 0.65;
    if (v.cosPhi >= 0.95) {
        if (v.Hour >= 0 && v.Hour <= 7)
            p.price += v.Active * (v.Price + 0.006);
        else {
            if ((v.Hour >= 8 && v.Hour <= 10) || (v.Hour >= 15 && v.Hour <= 23))
                p.price += v.Active * (v.Price + 0.027);
            else
                p.price += v.Active * (v.Price + 0.043);
        }
    }
    else {
        if (v.cosPhi >= 0.80 && v.cosPhi < 0.95) {
            if (v.Hour >= 0 && v.Hour <= 7)
                p.price += v.Active * (v.Price + 0.006) + v.Active * 0.04;
            else {
                if ((v.Hour >= 8 && v.Hour <= 10) || (v.Hour >= 15 && v.Hour <= 23))
                    p.price += v.Active * (v.Price + 0.027) + v.Active * 0.04;
                else
                    p.price += v.Active * (v.Price + 0.043) + v.Active * 0.04;
            }
        }
        else {
            if (v.Hour >= 0 && v.Hour <= 7)
                p.price += v.Active * (v.Price + 0.006) + v.Active * 0.06;
            else {
                if ((v.Hour >= 8 && v.Hour <= 10) || ( v.Hour >= 15 && v.Hour <= 23))
                    p.price += v.Active * (v.Price + 0.027) + v.Active * 0.06;
                else
                    p.price += v.Active * (v.Price + 0.043) + v.Active * 0.06;
            }
        }
    }
    
    if (p.count != 0) {
        p.avg = p.price / p.count;
        p.avgEnergy = p.totalKwhGroup / p.count;
        p.avgCO2 = p.totalCO2Group / p.count;
        if (p.count > 24) {
            p.avgWeekday = p.price / Math.floor(p.count / 24);
            p.avgWeekdayEnergy = p.totalKwhGroup / Math.floor(p.count / 24);
            p.avgCO2Weekday = p.totalCO2Group / Math.floor(p.count / 24);

        }
        else {
            p.avgWeekday = p.price / p.count;
            p.avgWeekdayEnergy = p.totalKwhGroup / p.count;
            p.avgCO2Weekday = p.totalCO2Group / p.count;
        }
    }
    else {
        p.avg = 0;
        p.avgWeekday = 0;
        p.avgEnergy = 0;
        p.avgWeekdayEnergy = 0;
        p.avgCO2 = 0;
        avgCO2Weekday = 0;
    }
    return p;
}
function reduceRemove(p, v) {
    --p.count;
    p.hourPrice = v.Price;
    p.totalKwhGroup -= v.Active;
    p.totalCO2Group = p.totalKwhGroup * 0.65;
    if (v.cosPhi >= 0.95) {
        if (v.Hour >= 0 && v.Hour <= 7)
            p.price -= v.Active * (v.Price + 0.006);
        else {
            if ((v.Hour >= 8 && v.Hour <= 10) || (v.Hour >= 15 && v.Hour <= 23))
                p.price -= v.Active * (v.Price + 0.027);
            else
                p.price -= v.Active * (v.Price + 0.043);
        }
    }
    else {
        if (v.cosPhi >= 0.80 && v.cosPhi < 0.95) {
            if (v.Hour >= 0 && v.Hour <= 7)
                p.price -= v.Active * (v.Price + 0.006) + v.Active * 0.04;
            else {
                if ((v.Hour >= 8 && v.Hour <= 10) || (v.Hour >= 15 && v.Hour <= 23))
                    p.price -= v.Active * (v.Price + 0.027) + v.Active * 0.04;
                else
                    p.price -= v.Active * (v.Price + 0.043) + v.Active * 0.04;
            }
        }
        else {
            if (v.Hour >= 0 && v.Hour <= 7)
                p.price -= v.Active * (v.Price + 0.006) + v.Active * 0.06;
            else {
                if ((v.Hour >= 8 && v.Hour <= 10) || (v.Hour >= 15 && v.Hour <= 23))
                    p.price -= v.Active * (v.Price + 0.027) + v.Active * 0.06;
                else
                    p.price -= v.Active * (v.Price + 0.043) + v.Active * 0.06;
            }
        }
    }
    if (p.count != 0) {
        p.avg = p.price / p.count;
        p.avgEnergy = p.totalKwhGroup / p.count;
        p.avgCO2 = p.totalCO2Group / p.count;

        if (p.count > 24) {
            p.avgWeekday = p.price / Math.floor(p.count / 24);
            p.avgWeekdayEnergy = p.totalKwhGroup / Math.floor(p.count / 24);
            p.avgCO2Weekday = p.totalCO2Group / Math.floor(p.count / 24);

        }
        else {
            p.avgWeekday = p.price / p.count;
            p.avgWeekdayEnergy = p.totalKwhGroup / p.count;
            p.avgCO2Weekday = p.totalCO2Group / p.count;
        }
    }
    else {
        p.avg = 0;
        p.avgWeekday = 0;
        p.avgEnergy = 0;
        p.avgWeekdayEnergy = 0;
        p.avgCO2 = 0;
        avgCO2Weekday = 0;
    }
    return p;
}; 
function reduceInit() {
    return { count: 0, price: 0, avg: 0, avgWeekday: 0, avgCO2: 0, avgCO2Weekday : 0, avgEnergy :0, avgWeekdayEnergy:0,  hourPrice: 0, totalKwhGroup: 0, totalCO2Group: 0 };
}

//FUNCION PARA CALCULAR EL TAMAÑO DE UN SVG
function canvasSize(targetElement) {
    var newHeight = parseFloat(d3.select(targetElement).node().clientHeight);
    var newWidth = parseFloat(d3.select(targetElement).node().clientWidth);
    return [newWidth, newHeight];
}

//FUNCIONES PARA INFORMACION AL HACER HOVER SOBRE LOS ELEMENTOS DEL HISTOGRAMA 2D
function hover(hoverD) { 
    var datos = hoverD.value;

   Prueba = d3.select("#Cuadro_Inform")
            .append("text")
            .attr("class", "text_inform")
            .attr("x", 10)
            .attr("y", 10)
            .text(function (d) { return "Number of matches: " + datos + " "; }); 
}
function mouseOut() { 
    $('#Cuadro_Inform').empty();
}

//FUNCION PARA CREAR UN SCATTER
function Crear_Scatter(dimension, targetDiv) {
    /*
    var sizeScatter = canvasSize(targetDiv);
    margenHor1 = sizeScatter[1] / 3.5;
    margenVer1 = sizeScatter[1] / 12;

    datos = dimension.top(Infinity);
    for (i = 0; i < datos.length; i++) {
        datos[i].cosPhi = Math.floor(datos[i].cosPhi * 50) / 50;
        datos[i].Activa = Math.floor((datos[i].Active / 10) * 10)
        datos[i].contador = 1;
    }
    console.log(datos)
    for (i = 0; i < datos.length; i++) {
        for (j = 1; j < datos.length; j++) {
            if (datos[i].cosPhi == datos[j].cosPhi) {
                datos[i].contador++;
                datos[j].contador++;
            }
        }
    }
    console.log(datos);

    var Xmin_max = d3.extent(datos, function (d) { return d.Active });
    var Xescala = d3.scale.linear().domain(Xmin_max).range([margenHor1, sizeScatter[0] - margenHor1]);
    var Ymin_max = d3.extent(datos, function (d) { return d.cosPhi });
    var Yescala = d3.scale.linear().domain(Ymin_max).range([margenVer1, sizeScatter[1] - margenVer1]);

    var Colormax = d3.max(datos, function (d) { return d.contador; });
    var colorscale = d3.scale.quantize().domain([0, Colormax]).range(colorbrewer.Reds[7]);
    /*
        var len = x.length; console.log(len);
    
        for (i = 0; i < len; i++){
    
            if (x[i].key[1] >= 0.95)
            { x[i].color = 0; }
            else if (x[i].key[1] >= 0.80 && x[i].key[1] < 0.95)
            {  x[i].color = 1; }
            else { x[i].color = 2; };
        };
    
        var colorscale = d3.scale.ordinal().domain([0, 1, 2]).range(["green","orange", "red"]);
    */
/*  
var Axis_Yescala = d3.scale.linear().domain(Ymin_max).range([sizeScatter[1] - margenVer1, margenVer1]),
       Yaxis = d3.svg.axis().scale(Axis_Yescala).orient("left").ticks(8);

    var Xaxis = d3.svg.axis().scale(Xescala).orient("bottom").ticks(20);


    var coord = d3.select(targetDiv).selectAll("g")
        .data(datos)
        .enter()
        .append("g")
        .attr("transform", function (d) { return "translate(" + Xescala(d.Active) + "," + (sizeScatter[1] - Yescala(d.cosPhi)) + ")" });

    coord.append("circle")
            .attr("r", function (d) { return 5 })
            .style("fill", function (d) { return colorscale(d.contador); });
    //.on("click", filtrar);

    d3.select(targetDiv).append("g")
         .attr("class", "axis")
         .attr("transform", "translate(0," + (sizeScatter[1] - margenVer1) + ")")
         .call(Xaxis);

    d3.select(targetDiv).append("g")
         .attr("class", "axis")
         .attr("transform", "translate(" + margenHor1 + ",0)")
         .call(Yaxis);
*/
}
